# httplib monkey patch to support socket timeouts
# az@zitc.de /20050523

from httplib import HTTPConnection, HTTP, _CS_IDLE
from zLOG import LOG, INFO


def http_init(self, host='', port=None, strict=None, timeout=None):
    if port == 0: port = None
    self._setup(self._connection_class(host, port, strict, timeout))

def httpconn_init(self, host, port=None, strict=None, timeout=None):
    self.sock = None
    self._buffer = []
    self.__response = None
    self.__state = _CS_IDLE
    self._method = None
    self.timeout = timeout
    self._set_hostport(host, port)
    if strict is not None:
        self.strict = strict
    LOG('debug', INFO, dir(self))

def connect(self):
    """Connect to the host and port specified in __init__."""
    msg = "getaddrinfo returns an empty list"
    for res in socket.getaddrinfo(self.host, self.port, 0, socket.SOCK_STREAM):
        af, socktype, proto, canonname, sa = res
        try:
            self.sock = socket.socket(af, socktype, proto)
            if self.timeout is not None:
                self.sock.settimeout(self.timeout)
            if self.debuglevel > 0:
                print "connect: (%s, %s)" % (self.host, self.port)
            self.sock.connect(sa)
        except socket.error, msg:
            if self.debuglevel > 0:
                print 'connect fail:', (self.host, self.port)
            if self.sock:
                self.sock.close()
            self.sock = None
            continue
        break
    if not self.sock:
        raise socket.error, msg

HTTP.__init__ = http_init
HTTPConnection.__init__ = httpconn_init
HTTPConnection.connect = connect

LOG('MediaTool', INFO, '*** patched httplib to support socket timeouts ***')

