from Products.Archetypes.public import *


MediaReferenceSchema = BaseSchema + Schema((
    StringField(
        'mediaUID',
        mode = 'r',
        primary = True,
        widget = StringWidget(
            label = 'Media UID',
            label_msgid = 'label_media_uid',
	    description = 'The unique UID of the referenced media object.',
            description_msgid = 'help_media_uid',
            i18n_domain = 'mediaref'),
    ),
    StringField(
        'contentType',
        mode = 'r',
        widget = StringWidget(
            label = 'Content Type',
            label_msgid = 'label_content_type',
	    description = 'The content type of the referenced media object.',
            description_msgid = 'help_content_type',
            i18n_domain = 'mediaref'),
    ),
    StringField(
        'rendererName',
	required = True,
	vocabulary= 'getRendererVocabulary',
        widget = SelectionWidget(
            label = 'Renderer',
            label_msgid = 'label_renderer',
	    description = 'Select how the media object should be used.',
            description_msgid = 'help_renderer',
            i18n_domain = 'mediaref'),
    ),
    TextField(
        'properties',
        mode = 'r',
	accessor = 'displayProperties',
        widget = TextAreaWidget(
            label = 'Media Properties',
            label_msgid = 'label_media_properties',
	    description = 'Properties specific to this particular referenced media object.',
            description_msgid = 'help_media_properties',
            i18n_domain = 'mediaref'),
    ),
))

