## Script (Python) "media_icon"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=content_type, **args
##title=Find most specific icon for the given content type
##
from Products.CMFCore.utils import getToolByName

try:
    mtr = getToolByName(context, 'mimetypes_registry')
    lookup = mtr.lookup(content_type)
    mti = lookup[0]
    icon = container.restrictedTraverse(mti.icon_path)
    name = mti.name()
except:
    icon = container.restrictedTraverse('unknown.png')
    name = 'unknown mime type'

return {
    'icon': icon,
    'name': name,
    'tag': icon.tag(title=name, alt=name, **args),
}
