## Controller Python Script "reference_add"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind state=state
##bind subpath=traverse_subpath
##parameters=references=None, info=None, relationship='media'
##title=Add references to the given media uid/renderer tuples
##
from Products.CMFCore.utils import getToolByName
mtool = getToolByName(container, 'media_tool')
rtool = getToolByName(container, 'reference_catalog')

if not references:
    message = ('Please give a valid UID or object.', 'valid_uid_required')
    errors = { 'reference': message }
    return state.set(status='failure', errors=errors, portal_status_message=message)

records = {}
for i in info:
    key = i.get('uid', None)
    if key:
        records[key] = mtool.getRecordAttributes(i)

position = 0
for ref in rtool.getReferences(context, relationship):
    position = max(position, ref.getTargetObject().getPosition())

titles = []
for ref in references:
    info = records.get(ref)
    title = info['title']
    del info['title']
    del info['uid']
    position += 1
    media_ref = mtool.createMediaReference(ref, position=position, **info)
    context.addReference(media_ref, relationship=relationship)
    titles.append(title)

message = 'Reference(s) added. (%s)' % ', '.join(titles)
return state.set(status='success', portal_status_message=message)
