## Controller Python Script "media_reference_update"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind state=state
##bind subpath=traverse_subpath
##parameters=info=None
##title=Update properties for the given references
##
from Products.CMFCore.utils import getToolByName
mtool = getToolByName(container, 'media_tool')

records = {}
for i in info:
    key = i.get('uid', None)
    if key:
        records[key] = mtool.getRecordAttributes(i)

if not records:
    message = ('Please add one or more references first.', 'add_references_first')
    errors = { 'reference': message }
    return state.set(status='failure', errors=errors, portal_status_message=message)

for ref, info in records.items():
    del info['title']
    del info['uid']
    obj = mtool.getMediaReference(ref)
    obj.setProperties(**info)

message = 'Reference(s) updated.'
return state.set(status='success', portal_status_message=message)
